<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2007 osCommerce

  Released under the GNU General Public License
*/

// look in your $PATH_LOCALE/locale directory for available locales
// or type locale -a on the server.
// Examples:
// on RedHat try 'nl_NL'
// on FreeBSD try 'nl_NL.ISO_8859-1'
// on Windows try 'nl' or 'Dutch'

@setlocale(LC_TIME, 'nl_NL.ISO_8859-1' , 'Dutch');
   
define('DATE_FORMAT_SHORT', '%d.%m.%Y');        // strftime()
define('DATE_FORMAT_LONG', '%A, %d %B %Y');     // strftime()
define('DATE_FORMAT', 'd/m/Y');                 // date()
define('PHP_DATE_TIME_FORMAT', 'm/d/Y H:i:s'); // this is used for date()
define('DATE_TIME_FORMAT', DATE_FORMAT_SHORT . ' %H:%M:%S');
define('JQUERY_DATEPICKER_I18N_CODE', 'nl'); // http://jqueryui.com/demos/datepicker/#localization
define('JQUERY_DATEPICKER_FORMAT', 'dd/mm/yy'); // http://docs.jquery.com/UI/Datepicker/formatDate

////
// Return date in raw format
// $date should be in format mm/dd/yyyy
// raw date is in format YYYYMMDD, or DDMMYYYY
function tep_date_raw($date, $reverse = false) {
  if ($reverse) {
    return substr($date, 0, 2) . substr($date, 3, 2) . substr($date, 6, 4);
  } else {
    return substr($date, 6, 4) . substr($date, 3, 2) . substr($date, 0, 2);
  }
}

// if USE_DEFAULT_LANGUAGE_CURRENCY is true, use the following currency, instead of the applications default currency (used when changing language)
define('LANGUAGE_CURRENCY', 'EUR');

// Global entries for the <html> tag
define('HTML_PARAMS', 'dir="ltr" lang="nl"');

// charset for web pages and emails
define('CHARSET', 'utf-8');

// page title
define('TITLE', STORE_NAME);

// header text in includes/header.php
define('HEADER_TITLE_TOP', 'Beheer');
define('HEADER_TITLE_SUPPORT_SITE', 'Ondersteuning');
define('HEADER_TITLE_ONLINE_CATALOG', 'Online Catalogus');
define('HEADER_TITLE_ADMINISTRATION', 'Beheer');

// text for gender
define('MALE', 'Man');
define('FEMALE', 'Vrouw');

// text for date of birth example
define('DOB_FORMAT_STRING', 'dd/mm/yyyy');

// configuration box text in includes/boxes/configuration.php
define('BOX_HEADING_CONFIGURATION', 'Configuratie');
define('BOX_CONFIGURATION_MYSTORE', 'Mijn winkel');
define('BOX_CONFIGURATION_LOGGING', 'Logging');
define('BOX_CONFIGURATION_CACHE', 'Cache');
define('BOX_CONFIGURATION_ADMINISTRATORS', 'Beheerders');
define('BOX_CONFIGURATION_STORE_LOGO', 'Winkel Logo');

// modules box text in includes/boxes/modules.php
define('BOX_HEADING_MODULES', 'Modules');

// categories box text in includes/boxes/catalog.php
define('BOX_HEADING_CATALOG', 'Catalogus');
define('BOX_CATALOG_CATEGORIES_PRODUCTS', 'Categorien/Producten');
define('BOX_CATALOG_CATEGORIES_PRODUCTS_ATTRIBUTES', 'Product Attributen');
define('BOX_CATALOG_MANUFACTURERS', 'Fabrikanten');
define('BOX_CATALOG_REVIEWS', 'Beoordelingen');
define('BOX_CATALOG_SPECIALS', 'Aanbiedingen');
define('BOX_CATALOG_PRODUCTS_EXPECTED', 'Verwachte Producten');

// customers box text in includes/boxes/customers.php
define('BOX_HEADING_CUSTOMERS', 'Klanten');
define('BOX_CUSTOMERS_CUSTOMERS', 'Klanten');
define('BOX_CUSTOMERS_ORDERS', 'Verkopen');

// taxes box text in includes/boxes/taxes.php
define('BOX_HEADING_LOCATION_AND_TAXES', 'Landen / Belastingen');
define('BOX_TAXES_COUNTRIES', 'Landen');
define('BOX_TAXES_ZONES', 'Zones');
define('BOX_TAXES_GEO_ZONES', 'Belasting Zones');
define('BOX_TAXES_TAX_CLASSES', 'Belasting Klassen');
define('BOX_TAXES_TAX_RATES', 'Belasting Tarieven');

// reports box text in includes/boxes/reports.php
define('BOX_HEADING_REPORTS', 'Rapporten');
define('BOX_REPORTS_PRODUCTS_VIEWED', 'Bekeken Producten');
define('BOX_REPORTS_PRODUCTS_PURCHASED', 'Verkochte Producten');
define('BOX_REPORTS_ORDERS_TOTAL', 'Klanten Verkoop-totaal');

// tools text in includes/boxes/tools.php
define('BOX_HEADING_TOOLS', 'Hulpprogramma\'s');
define('BOX_TOOLS_ACTION_RECORDER', 'Actie Recorder');
define('BOX_TOOLS_BACKUP', 'Database Backup');
define('BOX_TOOLS_BANNER_MANAGER', 'Banner Manager');
define('BOX_TOOLS_CACHE', 'Cache Controle');
define('BOX_TOOLS_DEFINE_LANGUAGE', 'Talen Instellen');
define('BOX_TOOLS_MAIL', 'Verstuur E-mail');
define('BOX_TOOLS_NEWSLETTER_MANAGER', 'Nieuwsbrief');
define('BOX_TOOLS_SEC_DIR_PERMISSIONS', 'Maprechten');
define('BOX_TOOLS_SERVER_INFO', 'Server Info');
define('BOX_TOOLS_VERSION_CHECK', 'Versie Controle');
define('BOX_TOOLS_WHOS_ONLINE', 'Wie is Online');

// localizaion box text in includes/boxes/localization.php
define('BOX_HEADING_LOCALIZATION', 'Lokale Instellingen');
define('BOX_LOCALIZATION_CURRENCIES', 'Munteenheden');
define('BOX_LOCALIZATION_LANGUAGES', 'Talen');
define('BOX_LOCALIZATION_ORDERS_STATUS', 'Verkopen Status');

// javascript messages
define('JS_ERROR', 'Er zijn foutmeldingen ontstaan tijdens het verwerken van uw formulier!\nMaak alstublieft de volgende aanpassingen:\n\n');

define('JS_OPTIONS_VALUE_PRICE', '* Een nieuw product moet een prijs hebben\n');
define('JS_OPTIONS_VALUE_PRICE_PREFIX', '* Een nieuw product moet een prefix bij de prijs hebben\n');

define('JS_PRODUCTS_NAME', '* Het nieuwe product moet een naam hebben\n');
define('JS_PRODUCTS_DESCRIPTION', '* Het nieuwe product moet een beschrijving hebben\n');
define('JS_PRODUCTS_PRICE', '* Het nieuwe product moet een prijs hebben\n');
define('JS_PRODUCTS_WEIGHT', '* Het nieuwe product moet een gewicht hebben\n');
define('JS_PRODUCTS_QUANTITY', '* Het nieuwe product moet een hoeveelheid hebben\n');
define('JS_PRODUCTS_MODEL', '* Het nieuwe product moet een model hebben\n');
define('JS_PRODUCTS_IMAGE', '* Het nieuwe product moet een afbeelding hebben\n');

define('JS_SPECIALS_PRODUCTS_PRICE', '* Er moet een nieuwe prijs voor dit product worden bepaald\n');

define('JS_GENDER', '* Het \'Geslacht\' moet worden gekozen.\n');
define('JS_FIRST_NAME', '* De \'Voornaam\' moet uit minstens ' . ENTRY_FIRST_NAME_MIN_LENGTH . ' tekens bestaan.\n');
define('JS_LAST_NAME', '* De \'Achternaam\' moet uit minstens ' . ENTRY_LAST_NAME_MIN_LENGTH . ' tekens bestaan.\n');
define('JS_DOB', '* De \'Geboortedatum\' moet in het formaat xx/xx/xxxx (maand/dag/jaar) zijn.\n');
define('JS_EMAIL_ADDRESS', '* Het \'e-mail adres\' moet uit minstens ' . ENTRY_EMAIL_ADDRESS_MIN_LENGTH . ' tekens bestaan.');
define('JS_ADDRESS', '* De \'Straat\' moet uit minstens ' . ENTRY_STREET_ADDRESS_MIN_LENGTH . ' tekens bestaan.\n');
define('JS_POST_CODE', '* De \'Postcode\' moet uit minstens ' . ENTRY_POSTCODE_MIN_LENGTH . ' tekens bestaan. \n');
define('JS_CITY', '* De \'Plaats\' moet uit minstens ' . ENTRY_CITY_MIN_LENGTH . ' tekens bestaan.\n');
define('JS_STATE', '* De \'Provincie\' moet worden geselecteerd.\n');
define('JS_STATE_SELECT', '-- Kies hierboven --');
define('JS_ZONE', '* De \'Provincie\' moet worden gekozen uit de lijst voor dit land.');
define('JS_COUNTRY', '* Het \'Land\' moet worden geselecteerd.\n');
define('JS_TELEPHONE', '* Het \'Telefoonnummer\' moet uit minstens ' . ENTRY_TELEPHONE_MIN_LENGTH . ' tekens bestaan.\n');
define('JS_PASSWORD', '* Het \'Wachtwoord\' en de \'Bevestiging\' moeten overeenkomen en uit minstens ' . ENTRY_PASSWORD_MIN_LENGTH . ' tekens bestaan.\n');

define('JS_ORDER_DOES_NOT_EXIST', 'Verkoop nummer %s bestaat niet!');

define('CATEGORY_PERSONAL', 'Persoonlijke Gegevens');
define('CATEGORY_ADDRESS', 'Adres');
define('CATEGORY_CONTACT', 'Contact');
define('CATEGORY_COMPANY', 'Bedrijf');
define('CATEGORY_OPTIONS', 'Opties');

define('ENTRY_GENDER', 'Geslacht:');
define('ENTRY_GENDER_ERROR', '&nbsp;<span class="errorText">verplicht</span>');
define('ENTRY_FIRST_NAME', 'Voornaam:');
define('ENTRY_FIRST_NAME_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_FIRST_NAME_MIN_LENGTH . ' tekens</span>');
define('ENTRY_LAST_NAME', 'Achternaam:');
define('ENTRY_LAST_NAME_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_LAST_NAME_MIN_LENGTH . ' tekens</span>');
define('ENTRY_DATE_OF_BIRTH', 'Geboortedatum:');
define('ENTRY_DATE_OF_BIRTH_ERROR', '&nbsp;<span class="errorText">(bijv. 21/05/1970)</span>');
define('ENTRY_EMAIL_ADDRESS', 'E-mail adres:');
define('ENTRY_EMAIL_ADDRESS_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_EMAIL_ADDRESS_MIN_LENGTH . ' tekens</span>');
define('ENTRY_EMAIL_ADDRESS_CHECK_ERROR', '&nbsp;<span class="errorText">Het e-mail adres lijkt ongeldig te zijn!</span>');
define('ENTRY_EMAIL_ADDRESS_ERROR_EXISTS', '&nbsp;<span class="errorText">Dit e-mail adres is al gebruikt!</span>');
define('ENTRY_COMPANY', 'Bedrijfsnaam:');
define('ENTRY_STREET_ADDRESS', 'Straatnaam:');
define('ENTRY_STREET_ADDRESS_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_STREET_ADDRESS_MIN_LENGTH . ' tekens</span>');
define('ENTRY_SUBURB', 'Woonwijk:');
define('ENTRY_POST_CODE', 'Postcode:');
define('ENTRY_POST_CODE_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_POSTCODE_MIN_LENGTH . ' tekens</span>');
define('ENTRY_CITY', 'Woonplaats:');
define('ENTRY_CITY_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_CITY_MIN_LENGTH . ' tekens</span>');
define('ENTRY_STATE', 'Provincie:');
define('ENTRY_STATE_ERROR', '&nbsp;<span class="errorText">vereist</span>');
define('ENTRY_COUNTRY', 'Land:');
define('ENTRY_COUNTRY_ERROR', 'Je moet een land kiezen uit het menu.');
define('ENTRY_TELEPHONE_NUMBER', 'Telefoonnummer:');
define('ENTRY_TELEPHONE_NUMBER_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_TELEPHONE_MIN_LENGTH . ' tekens</span>');
define('ENTRY_FAX_NUMBER', 'Fax Nummer:');
define('ENTRY_NEWSLETTER', 'Nieuwsbrief:');
define('ENTRY_NEWSLETTER_YES', 'Ingeschreven');
define('ENTRY_NEWSLETTER_NO', 'Uitgeschreven');

// images
define('IMAGE_ANI_SEND_EMAIL', 'E-mail versturen');
define('IMAGE_BACK', 'Terug');
define('IMAGE_BACKUP', 'Backup');
define('IMAGE_CANCEL', 'Afbreken');
define('IMAGE_CONFIRM', 'Bevestig');
define('IMAGE_COPY', 'Kopieer');
define('IMAGE_COPY_TO', 'Kopieer naar');
define('IMAGE_DETAILS', 'Details');
define('IMAGE_DELETE', 'Verwijderen');
define('IMAGE_EDIT', 'Aanpassen');
define('IMAGE_EMAIL', 'E-mail');
define('IMAGE_EXPORT', 'Exporteer');
define('IMAGE_ICON_STATUS_GREEN', 'Actief');
define('IMAGE_ICON_STATUS_GREEN_LIGHT', 'Maak Actief');
define('IMAGE_ICON_STATUS_RED', 'Inactief');
define('IMAGE_ICON_STATUS_RED_LIGHT', 'Maak Inactief');
define('IMAGE_ICON_INFO', 'Info');
define('IMAGE_INSERT', 'Toevoegen');
define('IMAGE_LOCK', 'Op Slot');
define('IMAGE_MODULE_INSTALL', 'Installeer Module');
define('IMAGE_MODULE_REMOVE', 'Verwijder Module');
define('IMAGE_MOVE', 'Verplaats');
define('IMAGE_NEW_BANNER', 'Nieuwe Banner');
define('IMAGE_NEW_CATEGORY', 'Nieuwe Categorie');
define('IMAGE_NEW_COUNTRY', 'Nieuw Land');
define('IMAGE_NEW_CURRENCY', 'Nieuwe Munteenheid');
define('IMAGE_NEW_FILE', 'Nieuw Bestand');
define('IMAGE_NEW_FOLDER', 'Nieuwe Map');
define('IMAGE_NEW_LANGUAGE', 'Nieuwe Taal');
define('IMAGE_NEW_NEWSLETTER', 'Nieuwe Nieuwsbrief');
define('IMAGE_NEW_PRODUCT', 'Nieuw Product');
define('IMAGE_NEW_TAX_CLASS', 'Nieuwe Belasting Klasse');
define('IMAGE_NEW_TAX_RATE', 'Nieuw Belasting Tarief');
define('IMAGE_NEW_TAX_ZONE', 'Nieuwe Belasting Zone');
define('IMAGE_NEW_ZONE', 'Nieuwe Zone');
define('IMAGE_ORDERS', 'Verkopen');
define('IMAGE_ORDERS_INVOICE', 'Factuur');
define('IMAGE_ORDERS_PACKINGSLIP', 'Pakbon');
define('IMAGE_PREVIEW', 'Preview');
define('IMAGE_RESTORE', 'Herstel');
define('IMAGE_RESET', 'Reset');
define('IMAGE_SAVE', 'Bewaren');
define('IMAGE_SEARCH', 'Zoeken');
define('IMAGE_SELECT', 'Selecteer');
define('IMAGE_SEND', 'Verstuur');
define('IMAGE_SEND_EMAIL', 'Verstuur E-mail');
define('IMAGE_UNLOCK', 'Open');
define('IMAGE_UPDATE', 'Wijzigen');
define('IMAGE_UPDATE_CURRENCIES', 'Wijzig Wisselkoers');
define('IMAGE_UPLOAD', 'Upload');

define('ICON_CROSS', 'Fout');
define('ICON_CURRENT_FOLDER', 'Huidige Map');
define('ICON_DELETE', 'Verwijder');
define('ICON_ERROR', 'Fout');
define('ICON_FILE', 'Bestand');
define('ICON_FILE_DOWNLOAD', 'Download');
define('ICON_FOLDER', 'Map');
define('ICON_LOCKED', 'Op Slot');
define('ICON_PREVIOUS_LEVEL', 'Vorig Niveau');
define('ICON_PREVIEW', 'Preview');
define('ICON_STATISTICS', 'Statistieken');
define('ICON_SUCCESS', 'Uitgevoerd');
define('ICON_TICK', 'Waar');
define('ICON_UNLOCKED', 'Open');
define('ICON_WARNING', 'Waarschuwing');

// constants for use in tep_prev_next_display function
define('TEXT_RESULT_PAGE', 'Pagina %s van %d');
define('TEXT_DISPLAY_NUMBER_OF_BANNERS', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> banners)');
define('TEXT_DISPLAY_NUMBER_OF_COUNTRIES', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> Landen)');
define('TEXT_DISPLAY_NUMBER_OF_CUSTOMERS', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> klanten)');
define('TEXT_DISPLAY_NUMBER_OF_CURRENCIES', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> munteenheden)');
define('TEXT_DISPLAY_NUMBER_OF_ENTRIES', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> ingevoerde gegevens)');
define('TEXT_DISPLAY_NUMBER_OF_LANGUAGES', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> talen)');
define('TEXT_DISPLAY_NUMBER_OF_MANUFACTURERS', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> fabrikanten)');
define('TEXT_DISPLAY_NUMBER_OF_NEWSLETTERS', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> nieuwsbrieven)');
define('TEXT_DISPLAY_NUMBER_OF_ORDERS', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> verkopen)');
define('TEXT_DISPLAY_NUMBER_OF_ORDERS_STATUS', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> verkopen status)');
define('TEXT_DISPLAY_NUMBER_OF_PRODUCTS', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> producten)');
define('TEXT_DISPLAY_NUMBER_OF_PRODUCTS_EXPECTED', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> verwachte producten)');
define('TEXT_DISPLAY_NUMBER_OF_REVIEWS', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> product beoordelingen)');
define('TEXT_DISPLAY_NUMBER_OF_SPECIALS', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> producten in de aanbieding)');
define('TEXT_DISPLAY_NUMBER_OF_TAX_CLASSES', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> belasting klassen)');
define('TEXT_DISPLAY_NUMBER_OF_TAX_ZONES', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> belasting zones)');
define('TEXT_DISPLAY_NUMBER_OF_TAX_RATES', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> belasting tarieven)');
define('TEXT_DISPLAY_NUMBER_OF_ZONES', 'Zichtbaar <strong>%d</strong> van <strong>%d</strong> (van <strong>%d</strong> zones)');

define('PREVNEXT_BUTTON_PREV', '&lt;&lt;');
define('PREVNEXT_BUTTON_NEXT', '&gt;&gt;');

define('TEXT_DEFAULT', 'standaard');
define('TEXT_SET_DEFAULT', 'Maak Standaard');
define('TEXT_FIELD_REQUIRED', '&nbsp;<span class="fieldRequired">* Vereist</span>');

define('TEXT_CACHE_CATEGORIES', 'Categorien Box');
define('TEXT_CACHE_MANUFACTURERS', 'Fabrikanten Box');
define('TEXT_CACHE_ALSO_PURCHASED', 'Ook Gekocht Module');

define('TEXT_NONE', '--geen--');
define('TEXT_TOP', 'Boven');

define('ERROR_DESTINATION_DOES_NOT_EXIST', 'Fout: Bestemming bestaat niet.');
define('ERROR_DESTINATION_NOT_WRITEABLE', 'Fout: Bestemming niet schrijfbaar.');
define('ERROR_FILE_NOT_SAVED', 'Fout: Bestand upload niet bewaard.');
define('ERROR_FILETYPE_NOT_ALLOWED', 'Fout: Bestand upload van dit soort niet toegestaan.');
define('SUCCESS_FILE_SAVED_SUCCESSFULLY', 'De upload van het bestand is gelukt.');
define('WARNING_NO_FILE_UPLOADED', 'Waarschuwing: Geen bestand geladen.');
?>
