<?php 
define('OGONE_API_URL','https://secure.ogone.com/ncol/test/maintenancedirect.asp');

function generateSecureHash($postdata){
	$ogone_shasign = MODULE_PAYMENT_OGONEDIRECT_SHA_HASH;
	$SHAsign = $data = '';
	ksort($postdata);
	foreach($postdata as $key => $val) {
		$val = trim($val);
		$key = trim($key);
		if($val){
			$SHAsign.=strtoupper($key).'='.$val.trim($ogone_shasign);
			$data .=  strtoupper($key).'='.rawurlencode($val).'&';
		}
	}
	$SHAsign = hash("sha512", $SHAsign);
	$data .= 'SHASIGN='.rawurlencode(strtoupper(($SHAsign)));
	return $data;
}

function xmlObject2Array($xml){
	$xmlObject = simplexml_load_string($xml);
	$xmlArray  = @json_decode(@json_encode($xmlObject),1);
	return $xmlArray;
}

function curlPost($URL,$data) {
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $URL);
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
	$output = curl_exec($ch);
	curl_close($ch);
	return $output;
}
    
$set_ogone_page = $HTTP_GET_VARS['page'];
if(!empty($set_ogone_page)){
	$set_ogone_order = $HTTP_GET_VARS['oID'];
	if(!empty($set_ogone_order)){
		$action = (isset($HTTP_GET_VARS['action']) ? $HTTP_GET_VARS['action'] : '');
		$payMod = $HTTP_GET_VARS['payMod'];
		if (isset($action) && isset($payMod)) {
			if($payMod=="ogone"){
				if($action=="capture" || $action=="authcancel" || $action=="refund"){
					$oID = tep_db_prepare_input($HTTP_GET_VARS['oID']);
			        $comments = tep_db_prepare_input($HTTP_POST_VARS['comments']);
		
			        $order_updated = false;
			        $check_status_query = tep_db_query("select customers_name, customers_email_address, orders_status, date_purchased, payment_method, currency from " . TABLE_ORDERS . " where orders_id = '" . (int)$oID . "'");
			        $check_status = tep_db_fetch_array($check_status_query);
			        
			        $get_currency_qry = tep_db_query("select * from " . TABLE_CURRENCIES . " where code = '".$check_status['currency']."'");
			        $get_currency = tep_db_fetch_array($get_currency_qry);	
			        
			        $pmstring = $check_status['payment_method'];
					$findstr   = 'Ogone';
					$pos = strpos($pmstring, $findstr);				
			        
					if($pos!==false){
				        $orders_statuses = array();
				        $orders_status_array = array();
				        $orders_status_query = tep_db_query("select orders_status_id, orders_status_name from " . TABLE_ORDERS_STATUS . " where language_id = '" . (int)$languages_id . "'");
				        while ($orders_status = tep_db_fetch_array($orders_status_query)) {
					        $orders_statuses[] = array('id' => $orders_status['orders_status_id'],
							                               'text' => $orders_status['orders_status_name']);
					        $orders_status_array[$orders_status['orders_status_id']] = $orders_status['orders_status_name'];
				        }      
		
				        $check_orderstatushistory_query = tep_db_query("select orders_status_id , comments from " . TABLE_ORDERS_STATUS_HISTORY . "  where orders_id = '" . (int)$oID . "' and comments != '' order by orders_status_history_id desc");
				        $check_orderstatushistory = tep_db_fetch_array($check_orderstatushistory_query);
				        		        
				        $pspid = MODULE_PAYMENT_OGONE_PSPID;
				        $api_username = MODULE_PAYMENT_OGONE_API_USERNAME;
				        $api_password = MODULE_PAYMENT_OGONE_API_PASSWORD;	
				        
				        $amount = $HTTP_GET_VARS['amount'];

				        $ctp = $get_currency['thousands_point'];
				        $cdp = $get_currency['decimal_point'];
				        
				        if($ctp == "." || $cdp == ","){	
				        	$search = array('.',',');
				        	$replace = array('','.');			        	
				        	$amount = str_replace($search, $replace, $amount);				        	
				        }

						if($ctp == ","){		        	
				        	$amount = str_replace(',', '.', $amount);				        				        	
				        }
				        
				        if($action=="capture"){
				        	$amount_round = "";
					        $comments = $check_orderstatushistory['comments'];
					        $data = explode('<br>',$comments);
					        $data1 = explode(':',$data[1]);		        	
					        $pay_id = trim($data1[1]);				        
					        if(!empty($amount)){ $amount_round = round($amount,2)*100;} 					        
					        $oarray = array(
								'PSPID'=> $pspid,
								'USERID'=> $api_username,
								'PSWD'=> $api_password,
								'PAYID'=> $pay_id,
					        	'AMOUNT'=> $amount_round,
								'OPERATION' => 'SAS',					
							);
							generateSecureHash($oarray);
							$xmlResponse   =   curlPost(OGONE_API_URL,generateSecureHash($oarray));
							$responseArr   =   xmlObject2Array($xmlResponse) ;        
							$response      =   $responseArr['@attributes'];
							
							if((!empty($response['STATUS'])) && ($response['NCSTATUS'] == 0) && ($response['NCERROR'] == 0)) {
								if($response['STATUS']=='9'){
									$check_query_requested = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Payment Requested [Ogone]' limit 1");
									$check_requested = tep_db_fetch_array($check_query_requested);						
									$status_requested_id = $check_requested['orders_status_id'];
									$res_amount = $response['amount'];
									if($res_amount){ $amt = " <br> Amount: ".$res_amount; }
									$comment_orderstatus = "Shop OrderID: ".$response['orderID']." <br> Ogone PayID: ".$response['PAYID']." <br> Ogone status: ".$response['STATUS']."-Payment Requested".$amt;
									$sql_data_array = array('orders_id' => (int)$oID, 
									                                'orders_status_id' => $status_requested_id, 
									                                'date_added' => 'now()', 
									                                'customer_notified' => '1',
									                                'comments' => $comment_orderstatus);
									                                
									tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $status_requested_id . "', last_modified = now() where orders_id = '" . (int)$oID . "'");
									tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
									$order_updated = true;
									$success = "Payment request has been processed Successfully";
								}
								if($response['STATUS']=='91'){
									$check_query_processing = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Payment Processing [Ogone]' limit 1");
									$check_processing = tep_db_fetch_array($check_query_processing);						
									$status_processing_id = $check_processing['orders_status_id'];
									$res_amount = $response['amount'];
									if($res_amount){ $amt = " <br> Amount: ".$res_amount; }									
									$comment_orderstatus = "Shop OrderID: ".$response['orderID']." <br> Ogone PayID: ".$response['PAYID']." <br> Ogone status: ".$response['STATUS']."-Payment Processing".$amt;
									$sql_data_array = array('orders_id' => (int)$oID, 
									                                'orders_status_id' => $status_processing_id, 
									                                'date_added' => 'now()', 
									                                'customer_notified' => '1',
									                                'comments' => $comment_orderstatus);
									                                
									tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $status_processing_id . "', last_modified = now() where orders_id = '" . (int)$oID . "'");
									tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
									$order_updated = true;
									$success = "Payment request has been processed Successfully";
								}
							}
							else {
								$order_updated = false;
								$error = $response['NCERRORPLUS'];
							}
				        }
				        
				        if($action=="authcancel"){
					        $comments = $check_orderstatushistory['comments'];
					        $data = explode('<br>',$comments);
					        $data1 = explode(':',$data[1]);		        	
					        $pay_id = trim($data1[1]);	
			        		$oarray	=	array(
											'PSPID'=> $pspid,
											'USERID'=> $api_username,
											'PSWD'=> $api_password,
											'PAYID'=> $pay_id,
											'OPERATION' => 'DES',					
							 			);
							generateSecureHash($oarray);
							
							$xmlResponse   =   curlPost(OGONE_API_URL,generateSecureHash($oarray));
							$responseArr   =   xmlObject2Array($xmlResponse) ;        
							$response      =   $responseArr['@attributes'];					
			        	
							if((!empty($response['STATUS'])) && ($response['NCSTATUS'] == 0) && ($response['NCERROR'] == 0)) {
								if($response['STATUS']=='6'){
									$check_query_ac = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Author. Cancelled [Ogone]' limit 1");
								    $check_ac = tep_db_fetch_array($check_query_ac);
								    $check_ac_id = $check_ac['orders_status_id'];
									$comment_orderstatus = "Shop OrderID: ".$response['orderID']." <br> Ogone PayID: ".$response['PAYID']." <br> Ogone status: ".$response['STATUS']."-Author. Cancelled";
									$sql_data_array = array('orders_id' => (int)$oID, 
									                                'orders_status_id' => $check_ac_id, 
									                                'date_added' => 'now()', 
									                                'customer_notified' => '1',
									                                'comments' => $comment_orderstatus);
									                                
									tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $check_ac_id . "', last_modified = now() where orders_id = '" . (int)$oID . "'");
									tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
									$order_updated = true;
									$success = "Auth. Cancel request has been processed Successfully";
								}
								if($response['STATUS']=='61'){
									 $check_query_adw = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Author. deletion waiting [Ogone]' limit 1");
									 $check_adw = tep_db_fetch_array($check_query_adw);
									 $check_adw_id = $check_adw['orders_status_id'];
								 	 $comment_orderstatus = "Shop OrderID: ".$response['orderID']." <br> Ogone PayID: ".$response['PAYID']." <br> Ogone status: ".$response['STATUS']."Author. deletion waiting";
								 	 $sql_data_array = array('orders_id' => (int)$oID, 
						                                'orders_status_id' => $check_adw_id, 
						                                'date_added' => 'now()', 
						                                'customer_notified' => '1',
						                                'comments' => $comment_orderstatus);
						                                
							         tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $check_adw_id . "', last_modified = now() where orders_id = '" . (int)$oID . "'");
							         tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
							         $order_updated = true;
							         $success = "Auth. Cancel request has been processed Successfully";
								}
							}         
					        else {         	
					        	$order_updated = false;
					        	$error = $response['NCERRORPLUS'];
					        }      
				        }
				        
			        	if($action=="refund"){		        	
			        		$comments = $check_orderstatushistory['comments'];
					        $data = explode('<br>',$comments);
					        $data1 = explode(':',$data[1]);		        	
					        $pay_id = trim($data1[1]);		
					        
					        $cap_his_qry = "select distinct osh.orders_status_id, osh.comments, os.orders_status_name from ".TABLE_ORDERS_STATUS_HISTORY." osh left join ".TABLE_ORDERS_STATUS." os on osh.orders_status_id = os.orders_status_id where osh.orders_id = '".(int)$oID."' and (os.orders_status_name like '%Requested%') and osh.comments!= '' order by osh.orders_status_history_id desc";
							$cap_his_exec = tep_db_query($cap_his_qry);
							$cap_his_num = mysql_num_rows($cap_his_exec);			
							if($cap_his_num!=0){
								while($cap_his = tep_db_fetch_array($cap_his_exec)){
									$cap_his1 = explode('<br>',$cap_his['comments']);
									$cap_his = explode(':',$cap_his1[3]);
									$captured_amount = $cap_his[1];
								}
							}
					        
					        $refund_qry = "select distinct osh.orders_status_id, osh.comments, os.orders_status_name from ".TABLE_ORDERS_STATUS_HISTORY." osh left join ".TABLE_ORDERS_STATUS." os on osh.orders_status_id = os.orders_status_id where osh.orders_id = '".(int)$oID."' and os.orders_status_name = 'Refund [Ogone]' and osh.comments!= '' order by osh.orders_status_history_id desc";
					        $refund_exec = tep_db_query($refund_qry);
					        $refund_nums = mysql_num_rows($refund_exec);
					        
					        $tots_query = tep_db_query("select value from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . (int)$oID . "' and class = 'ot_total'");
							$tots_val = tep_db_fetch_array($tots_query);											
							$oCurr_qry = tep_db_query("select * from " . TABLE_CURRENCIES . " where code = '".$check_status['currency']."'");
							$oCurr = tep_db_fetch_array($oCurr_qry);	
							$totVal = number_format(tep_round($tots_val['value'] * $oCurr['value'], $oCurr['decimal_places']), $oCurr['decimal_places'], $oCurr['decimal_point'], $oCurr['thousands_point']);						
		
					        if($refund_nums!=0){
					        	while($fetch_refunds = tep_db_fetch_array($refund_exec)){				        		
					        		$fetch_refund = explode('<br>',$fetch_refunds['comments']);				        		
					        		$ref_amt = explode(':',$fetch_refund[3]);
					        		$refunds += trim($ref_amt[1]);				        		
					        	}
					        	$balTot = $captured_amount - $refunds;
					        	if($balTot == $amount){
					        		$opCode = 'RFS';
					        	}
					        	else{
					        		$opCode = 'RFD';
					        	}
					        }
					        else{
					        	if($captured_amount == $amount){
					        		$opCode = 'RFS';
					        	}
					        	else{
					        		$opCode = 'RFD';
					        	}
					        }							        
					        $amount_round = round($amount,2)*100;					        
			        		$oarray	=	array(
											'PSPID'=> $pspid,
											'USERID'=> $api_username,
											'PSWD'=> $api_password,
											'PAYID'=> $pay_id,
			        						'AMOUNT' => $amount_round,
											'OPERATION' => $opCode,					
							 			);
							generateSecureHash($oarray);
							
							$xmlResponse   =   curlPost(OGONE_API_URL,generateSecureHash($oarray));
							$responseArr   =   xmlObject2Array($xmlResponse) ;        
							$response      =   $responseArr['@attributes'];		
			        	
							if((!empty($response['STATUS'])) && ($response['NCSTATUS'] == 0) && ($response['NCERROR'] == 0)) {
								if($response['STATUS']=='8'){
									$check_query_refund = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Refund [Ogone]' limit 1");
								    $check_refund = tep_db_fetch_array($check_query_refund);
								    $check_refund_id = $check_refund['orders_status_id'];
									$res_amount = $response['amount'];
									if($res_amount){ $amt = " <br> Amount: ".$res_amount; }									
									$comment_orderstatus = "Shop OrderID: ".$response['orderID']." <br> Ogone PayID: ".$response['PAYID']." <br> Ogone status: ".$response['STATUS']."-Refund".$amt;
									$sql_data_array = array('orders_id' => (int)$oID, 
									                                'orders_status_id' => $check_refund_id, 
									                                'date_added' => 'now()', 
									                                'customer_notified' => '1',
									                                'comments' => $comment_orderstatus);
									                                
									tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $check_refund_id . "', last_modified = now() where orders_id = '" . (int)$oID . "'");
									tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
									$order_updated = true;
									$success = "Refund request has been processed Successfully";
								}
								if($response['STATUS']=='81'){
									 $check_query_refund = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Refund Pending [Ogone]' limit 1");
									 $check_refund = tep_db_fetch_array($check_query_refund);
									 $check_refund_id = $check_refund['orders_status_id'];
									 $res_amount = $response['amount'];
								 	 if($res_amount){ $amt = " <br> Amount: ".$res_amount; }									
									 $comment_orderstatus = "Shop OrderID: ".$response['orderID']." <br> Ogone PayID: ".$response['PAYID']." <br> Ogone status: ".$response['STATUS']."-Refund Pending".$amt;
								 	 $sql_data_array = array('orders_id' => (int)$oID, 
						                                'orders_status_id' => $check_refund_id, 
						                                'date_added' => 'now()', 
						                                'customer_notified' => '1',
						                                'comments' => $comment_orderstatus);
						                                
							         tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $check_refund_id . "', last_modified = now() where orders_id = '" . (int)$oID . "'");
							         tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
							         $order_updated = true;
							         $success = "Refund request has been processed Successfully";
								}
							}         
					        else {         	
					        	$order_updated = false;
					        	$error = $response['NCERRORPLUS'];
					        }			        		
				        }
						
			        	if ($order_updated == true) {
				        	if (isset($HTTP_POST_VARS['notify']) && ($HTTP_POST_VARS['notify'] == 'on')) {
				       			$notify_comments = '';
				        		if (isset($HTTP_POST_VARS['notify_comments']) && ($HTTP_POST_VARS['notify_comments'] == 'on')) {
				        			$notify_comments = sprintf(EMAIL_TEXT_COMMENTS_UPDATE, $comments) . "\n\n";
				        		}
						        $email = STORE_NAME . "\n" . EMAIL_SEPARATOR . "\n" . EMAIL_TEXT_ORDER_NUMBER . ' ' . $oID . "\n" . EMAIL_TEXT_INVOICE_URL . ' ' . tep_catalog_href_link(FILENAME_CATALOG_ACCOUNT_HISTORY_INFO, 'order_id=' . $oID, 'SSL') . "\n" . EMAIL_TEXT_DATE_ORDERED . ' ' . tep_date_long($check_status['date_purchased']) . "\n\n" . $notify_comments . sprintf(EMAIL_TEXT_STATUS_UPDATE, $orders_status_array[$status]);
						        tep_mail($check_status['customers_name'], $check_status['customers_email_address'], EMAIL_TEXT_SUBJECT, $email, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
						        $customer_notified = '1';
				        	}
				        	$messageStack->add_session($success, 'success');
				        }
				        else {
				        	$messageStack->add_session($error, 'warning');
				        }			        
						$param = 'page=1&oID='.(int)$oID.'&action=edit';
						tep_redirect(tep_href_link(FILENAME_ORDERS, $param));
			        }
				}
			}	
		}
    
	}
}

?>