<?php
define('FILENAME_CHECKOUT_SUCCESS_OGONE', 'checkout_success_opg.php');

class ogone {
    var $code, $title, $description, $enabled;
    
	// class constructor
    function ogone() {
	    global $order;
	    $this->code = 'ogone';
	    $this->title = MODULE_PAYMENT_OGONE_TEXT_TITLE;
	    $this->description = MODULE_PAYMENT_OGONE_TEXT_DESCRIPTION;
	    $this->sort_order = MODULE_PAYMENT_OGONE_SORT_ORDER;
	    $this->enabled = ((MODULE_PAYMENT_OGONE_STATUS == 'True') ? true : false);			                              
	    switch (MODULE_PAYMENT_OGONE_TESTMODE) {
	        case 'PRODUCTION':
		        if(MODULE_PAYMENT_OGONE_UTFOPTION == 'YES') {
		        	$this->form_action_url = 'https://secure.ogone.com/ncol/prod/orderstandard_UTF8.asp';	       			
		        }
		        else {
		        	$this->form_action_url = 'https://secure.ogone.com/ncol/prod/orderstandard.asp';	
		        }          
			break;
	
	        default:
		        if(MODULE_PAYMENT_OGONE_UTFOPTION == 'YES') {       		
		        	$this->form_action_url = 'https://secure.ogone.com/ncol/test/orderstandard_utf8.asp';	       			
		        }
		        else {
		        	$this->form_action_url = 'https://secure.ogone.com/ncol/test/orderstandard.asp';	
		        }  
	        break;
	    }	    
	}

	// class methods
    function javascript_validation() {}
    
    function generateSelect($name = '', $options = array()) {
    	$html = '<select name="'.$name.'">';
    	foreach ($options as $option => $value) {
    		$html .= '<option value='.$value.'>'.$option.'</option>';
    	}
    	$html .= '</select>';
    	return $html;
    }

    function selection() {
    	global $order, $cart_ogone_standard_id, $cart_ogone_cancelled_id, $cart_ogone_last_processed_id;
    	
    	for ($i=1; $i < 13; $i++) {
    		$expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
    	}
    	$today = getdate();
    	for ($i=$today['year']; $i < $today['year']+10; $i++) {
    		$expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
    	}
    	
    	$ogoneParams = array();
		foreach ($_GET as $key => $value){
			if (strtoupper($key) != 'SHASIGN' AND $value != ''){
				$ogoneParams[strtoupper($key)] = $value;
			}
		}
    	
   		if(isset($ogoneParams['ORDERID'])){
			$ogOrderID = $ogoneParams['ORDERID'];
			$ogStatID = $ogoneParams['STATUS'];			
			if(!empty($ogStatID) &&  !empty($ogOrderID)){	
											
				ksort($ogoneParams);
				$shasign = '';					
				foreach ($ogoneParams as $key => $value)
				$shasign .= strtoupper($key).'='.$value.MODULE_PAYMENT_OGONE_SHA_OUTHASH;
				$sha_hash = hash("sha512", $shasign);
				$sha_hash = strtoupper($sha_hash);					
				if($sha_hash != $_GET['SHASIGN']){
					tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_OGONE_TEXT_ERROR_MESSAGE), 'SSL', true, false));	
				}
									
				if($ogStatID=='1'){
					$cart_ogone_cancelled_id = $ogOrderID;
				    tep_session_register('cart_ogone_cancelled_id');
				    tep_session_unregister('cart_ogone_last_processed_id');		
				    					
					$ogone_statuses = $this->get_ogone_statuses();
					$og_status_id = $ogoneParams['STATUS'];
			   		$og_stat_id = $og_status_id;
					$status_name = $ogone_statuses[$og_stat_id];
					$og_amt = '';
					$res_amount = $ogoneParams['AMOUNT'];
					if($res_amount){ $og_amt = " <br> Amount: ".$res_amount; }	
									
					if(!empty($status_name)){
						$my_status_query = tep_db_query("select orders_status from ".TABLE_ORDERS." where orders_id = '".$ogOrderID."'");
				        $current_status_id = "";
				        $update_status = true;				 
				               
				        if (tep_db_num_rows($my_status_query) > 0){
				            $stat = tep_db_fetch_array($my_status_query);
				            $current_status_id = (int)$stat['orders_status'];
				        }				       
				        
				        $status_id_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = '".$status_name."' limit 1");
						$status_id_fetch = tep_db_fetch_array($status_id_query);
						$status_id = $status_id_fetch['orders_status_id'];	

			        	if($current_status_id == $status_id){
			        		$update_status = false;				
			        	}			        	
			        	if($update_status){
			        		$orderid = $ogoneParams['ORDERID'];
			        		$stat_exp = explode('[',$status_name);			        		
							$comment_orderstatus = "Shop OrderID: ".$orderid." <br> Ogone PayID: ".$ogoneParams['PAYID']." <br> Ogone status: ".$og_status_id."-".$stat_exp[0].$og_amt;
							$sql_data_array = array('orders_id' => (int)$orderid,
						                                'orders_status_id' => $status_id, 
						                                'date_added' => 'now()', 
						                                'customer_notified' => '1',
						                                'comments' => $comment_orderstatus);
							$qry = "update " . TABLE_ORDERS . " set orders_status = '" . $status_id . "', last_modified = now() where orders_id = '" . (int)$orderid . "'";
							tep_db_query($qry);
							tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
			        	}
					}
				}
			}
		}
		
    	if(MODULE_PAYMENT_OGONE_PAYMENTMETHODSELECTION == 'YES'){
    		$selection = array('id' => $this->code, 'module' => $this->title);
    		
    		$ogone_brands = array();
    		$ogone_brand_arr = unserialize(MODULE_PAYMENT_OGONE_BRAND);
    		$ogone_get_brands = $this->ogone_get_brands();   
    		if(!empty($ogone_brand_arr)){  		
	    		foreach($ogone_brand_arr as $key=>$val) { 
	    			$ogone_brands[] = array('id' => $val, 'text' => $ogone_get_brands[$val]);
	    		}
    		}    		
    		
    		$today = getdate();    		
	        $months_array = array();
	        for ($i=1; $i<13; $i++) {
	        	$months_array[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
	        }
	        $year_valid_from_array = array();
	        for ($i=$today['year']-10; $i < $today['year']+1; $i++) {
	        	$year_valid_from_array[] = array('id' => strftime('%Y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
	        }
	        $year_expires_array = array();
	        for ($i=$today['year']; $i < $today['year']+10; $i++) {
	        	$year_expires_array[] = array('id' => strftime('%Y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
	        }        
	        $selection['id']     = $this->code;
	        $selection['module'] = $this->title;

	        if(!empty($ogone_brands)){
		        $selection['fields'] = array(   
		                                    array('title' => MODULE_PAYMENT_OGONE_PAYMENT_METHODS, 'field' => tep_draw_pull_down_menu('BRAND', $ogone_brands))                        
	                                    );
	        }
    	}
		else {
			$selection = array('id' => $this->code,
							'module' => $this->title,
							'fields' => array(
			             ));
		}
		return $selection;
    }


    function pre_confirmation_check() {	   
	    global $cartID, $cart;	
	    if (empty($cart->cartID)) {
	    	$cartID = $cart->cartID = $cart->generate_cart_id();
	    }	
	    if (!tep_session_is_registered('cartID')) {
	    	tep_session_register('cartID');
	    }
    }

    function confirmation() {    
    	global $cartID, $cart_ogone_standard_id, $customer_id, $languages_id, $order, $order_total_modules, $cart_ogone_cancelled_id, $cart_ogone_last_processed_id;
    	if (tep_session_is_registered('cartID')) {
    		$insert_order = false;
    		if (tep_session_is_registered('cart_ogone_standard_id')) {
    			$order_id = substr($cart_ogone_standard_id, strpos($cart_ogone_standard_id, '-')+1);
    			$curr_check = tep_db_query("select currency from " . TABLE_ORDERS . " where orders_id = '" . (int)$order_id . "'");
    			$curr = tep_db_fetch_array($curr_check);
    			
    			if($cart_ogone_last_processed_id!=$order_id){    			    			
			    	if (($curr['currency'] != $order->info['currency']) || ($cartID != substr($cart_ogone_standard_id, 0, strlen($cartID))) || ($cart_ogone_cancelled_id==$order_id)) {
	    				$check_query = tep_db_query('select orders_id from ' . TABLE_ORDERS_STATUS_HISTORY . ' where orders_id = "' . (int)$order_id . '" limit 1');
				    	if (tep_db_num_rows($check_query) < 1) {
					    	tep_db_query('delete from ' . TABLE_ORDERS . ' where orders_id = "' . (int)$order_id . '"');
					    	tep_db_query('delete from ' . TABLE_ORDERS_TOTAL . ' where orders_id = "' . (int)$order_id . '"');
					    	tep_db_query('delete from ' . TABLE_ORDERS_STATUS_HISTORY . ' where orders_id = "' . (int)$order_id . '"');
					    	tep_db_query('delete from ' . TABLE_ORDERS_PRODUCTS . ' where orders_id = "' . (int)$order_id . '"');
					    	tep_db_query('delete from ' . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . ' where orders_id = "' . (int)$order_id . '"');
					    	tep_db_query('delete from ' . TABLE_ORDERS_PRODUCTS_DOWNLOAD . ' where orders_id = "' . (int)$order_id . '"');
				    	}
				    	tep_session_unregister('cart_ogone_cancelled_id');
				    	$insert_order = true;
	    			}	    			
    			}
    			else{
    				$insert_order = false;
    			}
    		}
    		else {
    			$insert_order = true;
    		}
    		
    		if($insert_order == true) {
    			$order_totals = array();
    			if (is_array($order_total_modules->modules)) {
    				reset($order_total_modules->modules);
    				while (list(, $value) = each($order_total_modules->modules)) {
    					$class = substr($value, 0, strrpos($value, '.'));
    					if ($GLOBALS[$class]->enabled) {
    						for ($i=0, $n=sizeof($GLOBALS[$class]->output); $i<$n; $i++) {
    							if (tep_not_null($GLOBALS[$class]->output[$i]['title']) && tep_not_null($GLOBALS[$class]->output[$i]['text'])) {
    								$order_totals[] = array('code' => $GLOBALS[$class]->code,
    														'title' => $GLOBALS[$class]->output[$i]['title'],
				                                            'text' => $GLOBALS[$class]->output[$i]['text'],
				                                            'value' => $GLOBALS[$class]->output[$i]['value'],
				                                            'sort_order' => $GLOBALS[$class]->sort_order);
    							}
    						}
    					}
    				}
    			}
    				
	    		$sql_data_array = array('customers_id' => $customer_id,
		                                  'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
		                                  'customers_company' => $order->customer['company'],
		                                  'customers_street_address' => $order->customer['street_address'],
		                                  'customers_suburb' => $order->customer['suburb'],
		                                  'customers_city' => $order->customer['city'],
		                                  'customers_postcode' => $order->customer['postcode'],
		                                  'customers_state' => $order->customer['state'],
		                                  'customers_country' => $order->customer['country']['title'],
		                                  'customers_telephone' => $order->customer['telephone'],
		                                  'customers_email_address' => $order->customer['email_address'],
		                                  'customers_address_format_id' => $order->customer['format_id'],
		                                  'delivery_name' => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
		                                  'delivery_company' => $order->delivery['company'],
		                                  'delivery_street_address' => $order->delivery['street_address'],
		                                  'delivery_suburb' => $order->delivery['suburb'],
		                                  'delivery_city' => $order->delivery['city'],
		                                  'delivery_postcode' => $order->delivery['postcode'],
		                                  'delivery_state' => $order->delivery['state'],
		                                  'delivery_country' => $order->delivery['country']['title'],
		                                  'delivery_address_format_id' => $order->delivery['format_id'],
		                                  'billing_name' => $order->billing['firstname'] . ' ' . $order->billing['lastname'],
		                                  'billing_company' => $order->billing['company'],
		                                  'billing_street_address' => $order->billing['street_address'],
		                                  'billing_suburb' => $order->billing['suburb'],
		                                  'billing_city' => $order->billing['city'],
		                                  'billing_postcode' => $order->billing['postcode'],
		                                  'billing_state' => $order->billing['state'],
		                                  'billing_country' => $order->billing['country']['title'],
		                                  'billing_address_format_id' => $order->billing['format_id'],
		                                  'payment_method' => $order->info['payment_method'],
		                                  'cc_type' => $order->info['cc_type'],
		                                  'cc_owner' => $order->info['cc_owner'],
		                                  'cc_number' => $order->info['cc_number'],
		                                  'cc_expires' => $order->info['cc_expires'],
		                                  'date_purchased' => 'now()',
		                                  'orders_status' => $order->info['order_status'],
		                                  'currency' => $order->info['currency'],
		                                  'currency_value' => $order->info['currency_value']
	    						);
		    	tep_db_perform(TABLE_ORDERS, $sql_data_array);
    			$insert_id = tep_db_insert_id();
		    	for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
		    		$sql_data_array = array('orders_id' => $insert_id,
		    								'title' => $order_totals[$i]['title'],
		                                    'text' => $order_totals[$i]['text'],
		                                    'value' => $order_totals[$i]['value'],
		                                    'class' => $order_totals[$i]['code'],
		                                    'sort_order' => $order_totals[$i]['sort_order']
		    						);
    				tep_db_perform(TABLE_ORDERS_TOTAL, $sql_data_array);
    			}

		    	for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
		    		$sql_data_array = array('orders_id' => $insert_id,
	                                    'products_id' => tep_get_prid($order->products[$i]['id']),
	                                    'products_model' => $order->products[$i]['model'],
	                                    'products_name' => $order->products[$i]['name'],
	                                    'products_price' => $order->products[$i]['price'],
	                                    'final_price' => $order->products[$i]['final_price'],
	                                    'products_tax' => $order->products[$i]['tax'],
	                                    'products_quantity' => $order->products[$i]['qty']
		    					);
			    	tep_db_perform(TABLE_ORDERS_PRODUCTS, $sql_data_array);
			    	$order_products_id = tep_db_insert_id();
	    			$attributes_exist = '0';
	    			if (isset($order->products[$i]['attributes'])) {
	    				$attributes_exist = '1';
	    				for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
	    					if (DOWNLOAD_ENABLED == 'true') {
	    						$attributes_query = "select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix, pad.products_attributes_maxdays, pad.products_attributes_maxcount , pad.products_attributes_filename
			                                       from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa
			                                       left join " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
			                                       on pa.products_attributes_id=pad.products_attributes_id
			                                       where pa.products_id = '" . $order->products[$i]['id'] . "'
			                                       and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "'
			                                       and pa.options_id = popt.products_options_id
			                                       and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "'
			                                       and pa.options_values_id = poval.products_options_values_id
			                                       and popt.language_id = '" . $languages_id . "'
			                                       and poval.language_id = '" . $languages_id . "'";
	    						$attributes = tep_db_query($attributes_query);
	    					}
	    					else {
	    						$attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa where pa.products_id = '" . $order->products[$i]['id'] . "' and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "' and pa.options_id = popt.products_options_id and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '" . $languages_id . "' and poval.language_id = '" . $languages_id . "'");
	    					}
	    					$attributes_values = tep_db_fetch_array($attributes);
	    					$sql_data_array = array('orders_id' => $insert_id,
			                                        'orders_products_id' => $order_products_id,
			                                        'products_options' => $attributes_values['products_options_name'],
			                                        'products_options_values' => $attributes_values['products_options_values_name'],
			                                        'options_values_price' => $attributes_values['options_values_price'],
			                                        'price_prefix' => $attributes_values['price_prefix']
	    										);
					    	tep_db_perform(TABLE_ORDERS_PRODUCTS_ATTRIBUTES, $sql_data_array);
					    	if ((DOWNLOAD_ENABLED == 'true') && isset($attributes_values['products_attributes_filename']) && tep_not_null($attributes_values['products_attributes_filename'])) {
	    						$sql_data_array = array('orders_id' => $insert_id,
			                                          'orders_products_id' => $order_products_id,
			                                          'orders_products_filename' => $attributes_values['products_attributes_filename'],
			                                          'download_maxdays' => $attributes_values['products_attributes_maxdays'],
			                                          'download_count' => $attributes_values['products_attributes_maxcount']);
	    						tep_db_perform(TABLE_ORDERS_PRODUCTS_DOWNLOAD, $sql_data_array);
	    					}
	    				}
	    			}
    			}
	    		$cart_ogone_standard_id = $cartID . '-' . $insert_id;
	    		tep_session_register('cart_ogone_standard_id');
	    		$cart_ogone_last_processed_id = $insert_id;
	    		tep_session_register('cart_ogone_last_processed_id');
    		}
    	}
    	return false;
    }


    function process_button() {    	
    	global $HTTP_POST_VARS, $order, $order_total_modules, $currencies, $currency, $customer_id, $cart_ogone_standard_id, $languages_id;
    	
    	if($HTTP_POST_VARS['PM'] == 'Others'){
    		$HTTP_POST_VARS['PM'] = '';
    	}
    	
    	$products_ordered = '';
    	for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
    		$products_ordered .= $order->products[$i]['qty'] . ' x ' . $order->products[$i]['name'] . ' (' . $order->products[$i]['model'] . ') = ' . $currencies->display_price($order->products[$i]['final_price'], $order->products[$i]['tax'], $order->products[$i]['qty']) . $products_ordered_attributes . "\n";
    	}
    	
    	$products_ordered .= "\n";
    	$order_totals = $order_total_modules->process();
    	for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
    		$products_ordered .= strip_tags($order_totals[$i]['title']) . ' ' . strip_tags($order_totals[$i]['text']) . "\n";
    	}
    	$Secret = MODULE_PAYMENT_OGONE_SHA_HASH;
    	$PSPID = MODULE_PAYMENT_OGONE_PSPID;
    	$Amount = round($this->format_currency($order->info['total']),2)*100;
    	$OrderID = substr($cart_ogone_standard_id, strpos($cart_ogone_standard_id, '-')+1);
    	$CN = $order->customer['firstname'].' '.$order->customer['lastname'];
    	$Email = $order->customer['email_address'];
    	$OwnerAddress = $order->customer['street_address'];
    	$OwnerZip =  $order->customer['postcode'];
    	$OwnerCty = $order->customer['country']['iso_code_2'];
    	$OwnerTown = $order->customer['city'];
    	$OwnerTelno =$order->customer['telephone'];
    	$COM = 'Order reference number '.$OrderID;
    	$osc_version = 'OGos121015';
    	
    	//Get Shop Language Code
     	$languages_query = tep_db_query("select languages_id, name, code, image, directory from " . TABLE_LANGUAGES . " where languages_id = ".$languages_id." limit 1");
     	$languages = tep_db_fetch_array($languages_query);
    	$ogoneLangArr = $this->ogone_languages();
		$langCode = array_search($languages['name'], $ogoneLangArr);
		if(empty($langCode)){
    		$langCode = "en_US"; // Default Ogone Language Code
		}
    			  
	   	$oarray = array(
					'PSPID'=> 		$PSPID,
					'AMOUNT'=> 		$Amount,
					'ORDERID'=> 	$OrderID,
					'CURRENCY'=> 	$currency,
					'LANGUAGE'=> 	$langCode,
		   			'ORIG'=> $osc_version,
					'CN'=> 			$CN,
					'EMAIL'=> 		$Email,
					'OWNERADDRESS'=> $OwnerAddress,
					'OWNERZIP'=> 	$OwnerZip,
					'OWNERCTY'=> 	$OwnerCty,
					'OWNERTOWN'=> 	$OwnerTown,
					'OWNERTELNO'=> 	$OwnerTelno,
					'COM'=> 		$COM, 
					'TITLE'=>  MODULE_PAYMENT_OGONE_TITLE,
					'BGCOLOR'=> MODULE_PAYMENT_OGONE_BGCOLOR,
					'TXTCOLOR' => MODULE_PAYMENT_OGONE_TXTCOLOR,
					'TBLBGCOLOR' => MODULE_PAYMENT_OGONE_TBLBGCOLOR,
					'TBLTXTCOLOR' => MODULE_PAYMENT_OGONE_TBLTXTCOLOR,
					'BUTTONBGCOLOR'=> MODULE_PAYMENT_OGONE_BUTTONBGCOLOR,
					'BUTTONTXTCOLOR' => MODULE_PAYMENT_OGONE_BUTTONTXTCOLOR,
					'LOGO' => MODULE_PAYMENT_OGONE_LOGO,
					'FONTTYPE' => MODULE_PAYMENT_OGONE_FONTTYPE,
					
					'TP' => MODULE_PAYMENT_OGONE_TP,
					'PM' => 'Credit Card',
					'BRAND' => $HTTP_POST_VARS['BRAND'],
					'WIN3DS' => MODULE_PAYMENT_OGONE_WINDOW,
					'PMLIST' => MODULE_PAYMENT_OGONE_PMLIST,
					'PMLISTTYPE' => MODULE_PAYMENT_OGONE_PMLISTTYPE,
					'HOMEURL' => MODULE_PAYMENT_OGONE_HOMEURL,
					'CATALOGURL' => MODULE_PAYMENT_OGONE_CATALOGURL,
					
					'OPERATION' => MODULE_PAYMENT_OGONE_OPERATION,
					'ACCEPTURL' => tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL'),
					'DECLINEURL' => tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'),
					'EXCEPTIONURL' => tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL'),
					'CANCELURL' => tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'),
				);
		$sha='';
		ksort($oarray);
		
		foreach($oarray as $k=>$v){
			if($v!=''){
				$v = trim($v);
				$process_button_string .= tep_draw_hidden_field($k,$v);
				$sha.=strtoupper($k).'='.$v.trim($Secret);
			}
		}
		
		$sha_hash = hash("sha512", $sha);
		$sha_hash =  strtoupper($sha_hash);
		$process_button_string .= tep_draw_hidden_field('SHASign',$sha_hash);
 		return $process_button_string;
    }


    function before_process() {
    	global $HTTP_POST_VARS, $insert_id, $_GET;
    	global $customer_id, $order, $order_totals, $sendto, $billto, $languages_id, $payment, $currencies, $cart, $cart_ogone_standard_id;
     	global $$payment;
     	
    	// To check the SHA out algorithm	
		$ogoneParams = array();
		foreach ($_GET as $key => $value)
		if (strtoupper($key) != 'SHASIGN' AND $value != '')
			$ogoneParams[strtoupper($key)] = $value;

		ksort($ogoneParams);
		print_r($ogoneParams);
		$shasign = '';
		
		foreach ($ogoneParams as $key => $value)
		$shasign .= strtoupper($key).'='.$value.MODULE_PAYMENT_OGONE_SHA_OUTHASH;
		$sha_hash = hash("sha512", $shasign);
		$sha_hash =  strtoupper($sha_hash);
		
		if ($sha_hash != $_GET['SHASIGN']){
			tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_OGONE_TEXT_ERROR_MESSAGE), 'SSL', true, false));	
		}
		
		$order_id = substr($cart_ogone_standard_id, strpos($cart_ogone_standard_id, '-')+1);
		$ogone_statuses = $this->get_ogone_statuses();
		$og_status_id = $ogoneParams['STATUS'];
		$status_name = $ogone_statuses[$og_status_id];		
	    $amt = '';	
		$res_amount = $ogoneParams['AMOUNT'];
		if($res_amount){ $amt = " <br> Amount: ".$res_amount; }
		
		if(!empty($status_name)){
			$my_status_query = tep_db_query("select orders_status from ".TABLE_ORDERS." where orders_id = '".$order_id."'");
	        $current_status_id = "";
	        $update_status = true;
	        
	        if (tep_db_num_rows($my_status_query) > 0){
	            $stat = tep_db_fetch_array($my_status_query);
	            $current_status_id = (int)$stat['orders_status'];
	        }
	       
	        $status_id_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = '".$status_name."' limit 1");
			$status_id_fetch = tep_db_fetch_array($status_id_query);
			$status_id = $status_id_fetch['orders_status_id'];
				
        	if($current_status_id == $status_id){
        		$update_status = false;				
        	}
        	
        	if($update_status){
        		$orderid = $ogoneParams['ORDERID'];
        		$stat_exp = explode('[',$status_name);
				$comment_orderstatus = "Shop OrderID: ".$orderid." <br> Ogone PayID: ".$ogoneParams['PAYID']." <br> Ogone status: ".$og_status_id."-".$stat_exp[0].$amt;
				$sql_data_array = array('orders_id' => (int)$orderid,
			                                'orders_status_id' => $status_id, 
			                                'date_added' => 'now()', 
			                                'customer_notified' => '1',
			                                'comments' => $comment_orderstatus);
				$qry = "update " . TABLE_ORDERS . " set orders_status = '" . $status_id . "', last_modified = now() where orders_id = '" . (int)$orderid . "'";
				tep_db_query($qry);
				tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
        	}
		}	

		// initialized for the email confirmation
		$products_ordered = '';
		$subtotal = 0;
		$total_tax = 0;

		for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
			// Stock Update - Joao Correia
			if (STOCK_LIMITED == 'true') {
				if (DOWNLOAD_ENABLED == 'true') {
					$stock_query_raw = "SELECT products_quantity, pad.products_attributes_filename
			                                FROM " . TABLE_PRODUCTS . " p
			                                LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES . " pa
			                                ON p.products_id=pa.products_id
			                                LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
			                                ON pa.products_attributes_id=pad.products_attributes_id
			                                WHERE p.products_id = '" . tep_get_prid($order->products[$i]['id']) . "'";
					// Will work with only one option for downloadable products
					// otherwise, we have to build the query dynamically with a loop
					$products_attributes = $order->products[$i]['attributes'];
					if (is_array($products_attributes)) {
						$stock_query_raw .= " AND pa.options_id = '" . $products_attributes[0]['option_id'] . "' AND pa.options_values_id = '" . $products_attributes[0]['value_id'] . "'";
					}
					$stock_query = tep_db_query($stock_query_raw);
				}
				else {
					$stock_query = tep_db_query("select products_quantity from " . TABLE_PRODUCTS . " where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
				}
				if (tep_db_num_rows($stock_query) > 0) {
					$stock_values = tep_db_fetch_array($stock_query);
					// do not decrement quantities if products_attributes_filename exists
					if ((DOWNLOAD_ENABLED != 'true') || (!$stock_values['products_attributes_filename'])) {
						$stock_left = $stock_values['products_quantity'] - $order->products[$i]['qty'];
					}
					else {
						$stock_left = $stock_values['products_quantity'];
					}
					tep_db_query("update " . TABLE_PRODUCTS . " set products_quantity = '" . $stock_left . "' where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
					if ( ($stock_left < 1) && (STOCK_ALLOW_CHECKOUT == 'false') ) {
						tep_db_query("update " . TABLE_PRODUCTS . " set products_status = '0' where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
					}
				}
			}
			// Update products_ordered (for bestsellers list)
			tep_db_query("update " . TABLE_PRODUCTS . " set products_ordered = products_ordered + " . sprintf('%d', $order->products[$i]['qty']) . " where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");

			//------insert customer choosen option to order--------
			$attributes_exist = '0';
			$products_ordered_attributes = '';
			if (isset($order->products[$i]['attributes'])) {
				$attributes_exist = '1';
				for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
					if (DOWNLOAD_ENABLED == 'true') {
						$attributes_query = "select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix, pad.products_attributes_maxdays, pad.products_attributes_maxcount , pad.products_attributes_filename
                                   from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                   left join " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                                   on pa.products_attributes_id=pad.products_attributes_id
                                   where pa.products_id = '" . $order->products[$i]['id'] . "'
                                   and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "'
                                   and pa.options_id = popt.products_options_id
                                   and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "'
                                   and pa.options_values_id = poval.products_options_values_id
                                   and popt.language_id = '" . $languages_id . "'
                                   and poval.language_id = '" . $languages_id . "'";
						$attributes = tep_db_query($attributes_query);
					}
					else {
						$attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa where pa.products_id = '" . $order->products[$i]['id'] . "' and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "' and pa.options_id = popt.products_options_id and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '" . $languages_id . "' and poval.language_id = '" . $languages_id . "'");
					}
					$attributes_values = tep_db_fetch_array($attributes);
					$products_ordered_attributes .= "\n\t" . $attributes_values['products_options_name'] . ' ' . $attributes_values['products_options_values_name'];
				}
			}
			
			//------insert customer choosen option eof ----
			$total_weight += ($order->products[$i]['qty'] * $order->products[$i]['weight']);
			$total_tax += tep_calculate_tax($total_products_price, $products_tax) * $order->products[$i]['qty'];
			$total_cost += $total_products_price;
			$products_ordered .= $order->products[$i]['qty'] . ' x ' . $order->products[$i]['name'] . ' (' . $order->products[$i]['model'] . ') = ' . $currencies->display_price($order->products[$i]['final_price'], $order->products[$i]['tax'], $order->products[$i]['qty']) . $products_ordered_attributes . "\n";
		}

		// lets start with the email confirmation
		$email_order = STORE_NAME . "\n" .
		EMAIL_SEPARATOR . "\n" .
		EMAIL_TEXT_ORDER_NUMBER . ' ' . $order_id . "\n" .
		EMAIL_TEXT_INVOICE_URL . ' ' . tep_href_link(FILENAME_ACCOUNT_HISTORY_INFO, 'order_id=' . $order_id, 'SSL', false) . "\n" .
		EMAIL_TEXT_DATE_ORDERED . ' ' . strftime(DATE_FORMAT_LONG) . "\n\n";
		
		if ($order->info['comments']) {
			$email_order .= tep_db_output($order->info['comments']) . "\n\n";
		}
		$email_order .= EMAIL_TEXT_PRODUCTS . "\n" .
		EMAIL_SEPARATOR . "\n" .
		$products_ordered .
		EMAIL_SEPARATOR . "\n";

		for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
			$email_order .= strip_tags($order_totals[$i]['title']) . ' ' . strip_tags($order_totals[$i]['text']) . "\n";
		}

		if ($order->content_type != 'virtual') {
			$email_order .= "\n" . EMAIL_TEXT_DELIVERY_ADDRESS . "\n" .
			EMAIL_SEPARATOR . "\n" .
			tep_address_label($customer_id, $sendto, 0, '', "\n") . "\n";
		}

		$email_order .= "\n" . EMAIL_TEXT_BILLING_ADDRESS . "\n" .
		EMAIL_SEPARATOR . "\n" .
		tep_address_label($customer_id, $billto, 0, '', "\n") . "\n\n";

		if (is_object($$payment)) {
			$email_order .= EMAIL_TEXT_PAYMENT_METHOD . "\n" .
			EMAIL_SEPARATOR . "\n";
			$payment_class = $$payment;
			$email_order .= $payment_class->title . "\n\n";
			if ($payment_class->email_footer) {
				$email_order .= $payment_class->email_footer . "\n\n";
			}
		}

		tep_mail($order->customer['firstname'] . ' ' . $order->customer['lastname'], $order->customer['email_address'], EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

		// send emails to other people
		if (SEND_EXTRA_ORDER_EMAILS_TO != '') {
			tep_mail('', SEND_EXTRA_ORDER_EMAILS_TO, EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
		}

		// load the after_process function from the payment modules
		$this->after_process();
		
		$cart->reset(true);
		
		// unregister session variables used during checkout
		tep_session_unregister('sendto');
		tep_session_unregister('billto');
		tep_session_unregister('shipping');
		tep_session_unregister('payment');
		tep_session_unregister('comments');
		tep_session_unregister('cart_ogone_standard_id');		
		tep_session_unregister('cart_ogone_last_processed_id');
		
		if($og_status_id=="92" || $og_status_id=="52"){
			$link = FILENAME_CHECKOUT_SUCCESS_OGONE."?payment=uncertain";
			tep_redirect(tep_href_link($link, '', 'SSL'));
		}
		else{
			tep_redirect(tep_href_link(FILENAME_CHECKOUT_SUCCESS_OGONE, '', 'SSL'));
		}		
    }

    function after_process() {
    	return false;
    }

    function get_error() {
    	global $HTTP_GET_VARS;
    	$error = array('title' => MODULE_PAYMENT_OGONE_TEXT_ERROR,
    	'error' => stripslashes(urldecode($HTTP_GET_VARS['error'])));
    	return $error;
    }

    function check() {
	    if (!isset($this->_check)) {
	    	$check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_OGONE_STATUS'");
	    	$this->_check = tep_db_num_rows($check_query);
	    }
	    return $this->_check;
    }

	function install() {
		$ogone_statuses = $this->get_ogone_statuses();
		foreach($ogone_statuses as $status_key => $status_value){
			$check_status_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = '".$status_value."' limit 1");
			if (tep_db_num_rows($check_status_query) < 1) {
				$status_query = tep_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
				$statuses = tep_db_fetch_array($status_query);
				$statuses_id = $statuses['status_id']+1;
				$languages = tep_get_languages();
				for ($i=0, $n=sizeof($languages); $i<$n; $i++) {
					tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $statuses_id . "', '" . $languages[$i]['id'] . "', '".$status_value."')");
				}
				$flags_query = tep_db_query("describe " . TABLE_ORDERS_STATUS . " public_flag");
				if (tep_db_num_rows($flags_query) == 1) {
					tep_db_query("update " . TABLE_ORDERS_STATUS . " set public_flag = 0 and downloads_flag = 0 where orders_status_id = '" . $statuses_id . "'");
				}
			}
			else {
				//return false;
			}
		}	
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('ENABLE OGONE PAYMENT MODULE', 'MODULE_PAYMENT_OGONE_STATUS', 'True', 'Do you want to accept OGONE payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('MODE', 'MODULE_PAYMENT_OGONE_TESTMODE', 'TEST', 'Mode used for the Environment', '6', '1', 'tep_cfg_select_option(array(\'TEST\', \'PRODUCTION\'), ', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('DEFAULT OPERATION OPTION', 'MODULE_PAYMENT_OGONE_OPERATION', 'SALE', 'Do you want to enable default operation mode', '6', '2', 'tep_cfg_select_option(array(\'SAL\', \'RES\'), ', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('OGONE PSPID', 'MODULE_PAYMENT_OGONE_PSPID', '', 'Your PSPID of OGONE', '6', '3', now())");
      	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('API USERNAME', 'MODULE_PAYMENT_OGONE_API_USERNAME', '', 'Your API username', '6', '4', now())");
      	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('API PASSWORD', 'MODULE_PAYMENT_OGONE_API_PASSWORD', '', 'Your API password', '6', '5', 'ogone::tep_show_password_ogone', 'ogone::tep_cfg_password_ogone(', now())");      	
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('DIRECT LINK SHA-IN PASS PHRASE', 'MODULE_PAYMENT_OGONEDIRECT_SHA_HASH', 'none', 'Your DIRECT LINK SHA-IN Pass phrase', '6', '6', 'ogone::tep_show_password_ogone', 'ogone::tep_cfg_password_ogone(', now())");
      	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('SHA-IN PASS PHRASE', 'MODULE_PAYMENT_OGONE_SHA_HASH', 'none', 'Your SHA-IN Pass phrase', '6', '7', 'ogone::tep_show_password_ogone', 'ogone::tep_cfg_password_ogone(', now())");	  
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('SHA-OUT PASS PHRASE', 'MODULE_PAYMENT_OGONE_SHA_OUTHASH', 'none', 'Your SHA-OUT Pass phrase', '6', '8', 'ogone::tep_show_password_ogone', 'ogone::tep_cfg_password_ogone(', now())");
      	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('SELECT THE PAYMENT METHOD OPTION', 'MODULE_PAYMENT_OGONE_PAYMENTMETHODSELECTION', 'No', 'Do you want to enable the ogone payment method selection in your front end', '6', '9', 'tep_cfg_select_option(array(\'YES\', \'NO\'), ', now())");
      	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('SET BRAND', 'MODULE_PAYMENT_OGONE_BRAND', '0', 'Select the Payment Brand', '6', '11',  'ogone::tep_get_brand_names','ogone::tep_cfg_pull_down_brand_classes(',now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('SELECT THE PAYMENT METHOD TEMPLATE', 'MODULE_PAYMENT_OGONE_TEMPLATE', 'No', 'Do you want to enable the ogone dynamic template', '6', '12', 'tep_cfg_select_option(array(\'YES\', \'NO\'), ', now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TEMPLATE TITLE', 'MODULE_PAYMENT_OGONE_TITLE', '', 'Enter the template title', '6', '13', now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TEMPLATE BGCOLOR', 'MODULE_PAYMENT_OGONE_BGCOLOR', '', 'Enter the template background color', '6', '14', now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TEMPLATE TXTCOLOR', 'MODULE_PAYMENT_OGONE_TXTCOLOR', '', 'Enter the template text color', '6', '15', now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TEMPLATE TBLBGCOLOR', 'MODULE_PAYMENT_OGONE_TBLBGCOLOR', '', 'Enter the template table background color', '6', '16', now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TEMPLATE TBLTXTCOLOR', 'MODULE_PAYMENT_OGONE_TBLTXTCOLOR', '', 'Enter the template table text color', '6', '17', now())");
      	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TEMPLATE BUTTONBGCOLOR', 'MODULE_PAYMENT_OGONE_BUTTONBGCOLOR', '', 'Enter the template button background color', '6', '18', now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TEMPLATE BUTTONTXTCOLOR', 'MODULE_PAYMENT_OGONE_BUTTONTXTCOLOR', '', 'Enter the template button text color', '6', '19', now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TEMPLATE LOGO', 'MODULE_PAYMENT_OGONE_LOGO', '', 'Enter the template logo', '6', '20', now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TEMPLATE FONTTYPE', 'MODULE_PAYMENT_OGONE_FONTTYPE', 'verdana', 'Enter the template font type', '6', '21', now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('UTF-8 OPTION', 'MODULE_PAYMENT_OGONE_UTFOPTION', 'NO', 'Do you want to Enable UTF-8 option', '6', '22', 'tep_cfg_select_option(array(\'YES\', \'NO\'), ', now())");
	 	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('TEMPLATE URL', 'MODULE_PAYMENT_OGONE_TP', '', 'Enter the template URL', '23', '0', now())");
	 	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PMLIST', 'MODULE_PAYMENT_OGONE_PMLIST', '', 'Enter the Payment method list', '24', '0', now())");
	 	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PMLISTTYPE', 'MODULE_PAYMENT_OGONE_PMLISTTYPE', '', 'Enter the Payment method list type', '25', '0', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('HOMEURL', 'MODULE_PAYMENT_OGONE_HOMEURL', '', 'Enter the home URL', '26', '0', now())");
	 	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('CATALOGURL', 'MODULE_PAYMENT_OGONE_CATALOGURL', '', 'Enter the Catalog URL', '27', '0', now())");
	  	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('DEFAULT WINDOW OPTION', 'MODULE_PAYMENT_OGONE_WINDOW', 'MAINW', 'Do you want to enable Window option', '6', '28', 'tep_cfg_select_option(array(\'MAINW\', \'POPUP\'), ', now())");
	}

	function remove() {
		tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
	}

    function keys() {
    	return array(
    		'MODULE_PAYMENT_OGONE_STATUS', 
    		'MODULE_PAYMENT_OGONE_TESTMODE',
    		'MODULE_PAYMENT_OGONE_OPERATION',
    		'MODULE_PAYMENT_OGONE_PSPID', 
    		'MODULE_PAYMENT_OGONE_API_USERNAME', 
    		'MODULE_PAYMENT_OGONE_API_PASSWORD', 
    		'MODULE_PAYMENT_OGONEDIRECT_SHA_HASH',
    		'MODULE_PAYMENT_OGONE_SHA_HASH',
    		'MODULE_PAYMENT_OGONE_SHA_OUTHASH',
    		'MODULE_PAYMENT_OGONE_PAYMENTMETHODSELECTION',   
    		'MODULE_PAYMENT_OGONE_BRAND',
    		'MODULE_PAYMENT_OGONE_TEMPLATE',
    		'MODULE_PAYMENT_OGONE_TITLE',
    		'MODULE_PAYMENT_OGONE_BGCOLOR',
    		'MODULE_PAYMENT_OGONE_TXTCOLOR',
    		'MODULE_PAYMENT_OGONE_TBLBGCOLOR',
    		'MODULE_PAYMENT_OGONE_TBLTXTCOLOR',
    		'MODULE_PAYMENT_OGONE_BUTTONBGCOLOR',
    		'MODULE_PAYMENT_OGONE_BUTTONTXTCOLOR',
    		'MODULE_PAYMENT_OGONE_LOGO',
    		'MODULE_PAYMENT_OGONE_FONTTYPE',    		
    		'MODULE_PAYMENT_OGONE_UTFOPTION',
    		'MODULE_PAYMENT_OGONE_TP',
    		'MODULE_PAYMENT_OGONE_PMLIST',
    		'MODULE_PAYMENT_OGONE_PMLISTTYPE',
    		'MODULE_PAYMENT_OGONE_HOMEURL',
    		'MODULE_PAYMENT_OGONE_CATALOGURL',
    		'MODULE_PAYMENT_OGONE_WINDOW'    		
    	);
    }
        
    function ogone_languages(){
    	$ogone_lanugages = array(
    					'en_US' => 'English',
    					'ar_AR' => 'Arabic',
    					'cs_CZ' => 'Czech',
    					'dk_DK' => 'Danish',
    					'de_DE' => 'German',
    					'el_GR' => 'Greek',
    					'es_ES' => 'Spanish',
    					'fi_FI' => 'Finnish',
    					'fr_FR' => 'French',
    					'he_IL' => 'Hebrew',
    					'hu_HU' => 'Hungarian',
    					'it_IT' => 'Italian',
    					'ja_JP' => 'Japanese',
    					'nl_NL' => 'Dutch',
    					'no_NO' => 'Norwegian',
    					'pl_PL' => 'Polish',
    					'pt_PT' => 'Portugese',
    					'ru_RU' => 'Russian',
    					'se_SE' => 'Swedish',
    					'sk_SK' => 'Slovak',
    					'tr_TR' => 'Turkish',
    					'zh_CN' => 'Simplified Chinese',
    				);
    	return $ogone_lanugages;
    }

    function tep_get_language_name() {
    	global $language_class_id;
    	if ($language_class_id == '0') {
    		return TEXT_NONE;
    	}
    	else {
    		$status_query = tep_db_query("select languages_id , name from " . TABLE_LANGUAGES  . " where languages_id = '" . $language_class_id . "'");
    		$status = tep_db_fetch_array($status_query);
    		return $status['name'];
    	}
    	    	
    }	
	
	function tep_cfg_pull_down_currency_classes($currency_class_id, $key = '') {
		$name = (($key) ? 'configuration[' . $key . ']' : 'configuration_value');
		$currency_class_array = array(array('id' => '0', 'text' => TEXT_NONE));
		$currency_class_query = tep_db_query("select currencies_id, code from " . TABLE_CURRENCIES . " order by currencies_id");
		while ($currency_class = tep_db_fetch_array($currency_class_query)) {
			$currency_class_array[] = array('id' => $currency_class['currencies_id'],'text' => $currency_class['code']);
		}
		return tep_draw_pull_down_menu($name, $currency_class_array, $currency_class_id);
	}

    function tep_get_currency_name($currency_class_id) {
    	if ($currency_class_id == '0') {
    		return TEXT_NONE;
    	}
    	else {
    		$status_query = tep_db_query("select currencies_id , code from " . TABLE_CURRENCIES . " where currencies_id = '" . (int)$currency_class_id . "'");
    		$status = tep_db_fetch_array($status_query);
    		return $status['code'];
    	}
    } 
    
	function tep_cfg_pull_down_brand_classes($brand_values, $key = ''){
    	$brands = ogone::ogone_get_brands();
		$name = (($key) ? 'configuration[' . $key . '][]' : 'configuration_value');
    	foreach($brands as $key => $value){
    		$brands_class_array[] = array('id' => $key,'text' => $value);
    	}
    	$brand_values = unserialize($brand_values);
    	return ogone::ogone_draw_pull_down_menu($name, $brands_class_array, $brand_values);
    }
    
	function tep_get_brand_names($brand_class_id){
	    $brand_names = unserialize($brand_class_id);	    
	    $brand = @implode(', ',$brand_names);
	    return $brand;
    }
    
	function ogone_draw_pull_down_menu($name, $values, $default = '') {
	    global $HTTP_GET_VARS, $HTTP_POST_VARS;
	    $field = '<select name="' . tep_output_string($name) . '" multiple="multiple">';
	    if (empty($default) && ( (isset($HTTP_GET_VARS[$name]) && is_string($HTTP_GET_VARS[$name])) || (isset($HTTP_POST_VARS[$name]) && is_string($HTTP_POST_VARS[$name])) ) ) {
	      if (isset($HTTP_GET_VARS[$name]) && is_string($HTTP_GET_VARS[$name])) {
	        $default = stripslashes($HTTP_GET_VARS[$name]);
	      } elseif (isset($HTTP_POST_VARS[$name]) && is_string($HTTP_POST_VARS[$name])) {
	        $default = stripslashes($HTTP_POST_VARS[$name]);
	      }
	    }
	    for ($i=0, $n=sizeof($values); $i<$n; $i++) {
	      $field .= '<option value="' . tep_output_string($values[$i]['id']) . '"';
	      if(!empty($default)){
		      foreach($default as $def_key=>$def_val){
			      if ($def_val == $values[$i]['id']) {
			        $field .= ' selected="selected"';
			      }
		      }
	      }
	      $field .= '>' . tep_output_string($values[$i]['text'], array('"' => '&quot;', '\'' => '&#039;', '<' => '&lt;', '>' => '&gt;')) . '</option>';
	    }
	    $field .= '</select>';	
	    return $field;
  	}
  	
  	function ogone_get_pms(){
  		$pms = array( );
	    return $pms;
  	}
  	
	function ogone_get_brands(){
  		$brands = array(
	    			'VISA' => 'VISA',
	    			'American Express' => 'American Express',
	    			'MasterCard' => 'MasterCard',
	    			'Diners' => 'Diners',
	    			'JCB' => 'JCB',
	    			'Maestro' => 'Maestro',
	    			'BC/MC' => 'BC/MC',
	    			'PostFinance Card' => 'PostFinance Card',
	    			'PostFinance e-Finance' => 'PostFinance e-Finance',
	    			'Dankort' => 'Dankort',
  					'Direct Debits DE' => 'ELV - Direct Debits DE',
  					'Direct Debits AT' => 'ELV - Direct Debits AT',
  					'Direct Debits NL' => 'Machtiging - Direct Debits NL',
  					'Paypal' => 'Paypal',
  					'Eps' => 'Eps',
  					'Sofortüberweisung' => 'Sofortüberweisung',
  					'iDeal' => 'iDeal',
  					'giropay' => 'giropay',
	    		);
	    return $brands;
  	}
  	
  	function get_ogone_statuses(){
  		$status = array(
  			'0' => 'Incomplete [Ogone]',
  			'1' => 'Cancelled by Customer [Ogone]',
  			'2' => 'Auth. declined [Ogone]',
  			'5' => 'Authorized [Ogone]',
  			'51' => 'Author. Waiting [Ogone]',
  			'52' => 'Auth. not known [Ogone]',
  			'6' => 'Author. Cancelled [Ogone]',
  			'61' => 'Author. deletion waiting [Ogone]',
  			'8' => 'Refund [Ogone]',
  			'81' => 'Refund Pending [Ogone]',
  			'82' => 'Refund Uncertain [Ogone]',
  			'83' => 'Refund Refused [Ogone]',
  			'9' => 'Payment Requested [Ogone]',
  			'91' => 'Payment Processing [Ogone]',
  			'92' => 'Payment Uncertain [Ogone]',
  			'93' => 'Payment Refused [Ogone]'  			
  		);
  		return $status;  	
  	}
  	
  	function tep_cfg_password_ogone($values, $key){
  		$name = (($key) ? 'configuration[' . $key . ']' : 'configuration_value');  		
  		return tep_draw_password_field($name, $values);
  	}
  	
	function tep_show_password_ogone($values){
		$val="";
  		if(!empty($values)){
  			$str_count = strlen($values);
  			for($i=0;$i<$str_count;$i++){
  				$val .= "*";
  			}
  		}  		
  		return $val;
  	}
  	
  	// format prices without currency formatting
	function format_currency($number, $currency_code = '', $currency_value = '') {
		global $currencies, $currency;
		if (empty($currency_code) || !$this->is_set($currency_code)) {
			$currency_code = $currency;
		}
		if (empty($currency_value) || !is_numeric($currency_value)) {
			$currency_value = $currencies->currencies[$currency_code]['value'];
		}
		return number_format(tep_round($number * $currency_value, $currencies->currencies[$currency_code]['decimal_places']), $currencies->currencies[$currency_code]['decimal_places'], '.', '');
    }
  
}
?>
