<?php
// check support for register_globals
if (function_exists('ini_get') && (ini_get('register_globals') == false) && (PHP_VERSION < 4.3) ) {
	exit('Server Requirement Error: register_globals is disabled in your PHP configuration. This can be enabled in your php.ini configuration file or in the .htaccess file in your catalog directory. Please use PHP 4.3+ if register_globals cannot be enabled on the server.');
}
// load server configuration parameters
if (file_exists('includes/local/configure.php')) { // for developers
	include('includes/local/configure.php');
}
else {
	include('includes/configure.php');
}

// include the list of project filenames
require(DIR_WS_INCLUDES . 'filenames.php');

// include the list of project database tables
require(DIR_WS_INCLUDES . 'database_tables.php');

// include the database functions
require(DIR_WS_FUNCTIONS . 'database.php');

// make a connection to the database... now
tep_db_connect() or die('Unable to connect to database server!');
 
// define general functions used application-wide
require(DIR_WS_FUNCTIONS . 'general.php');

require('includes/modules/payment/ogone.php');

$response = array();
foreach($_REQUEST as $key=>$value){
	$response[$key]= $value;
}

if(!empty($response)){
	$orders_statuses = array();
	$orders_status_array = array();
	$orders_status_query = tep_db_query("select orders_status_id, orders_status_name from " . TABLE_ORDERS_STATUS);
	while ($orders_status = tep_db_fetch_array($orders_status_query)) {
		$orders_statuses[] = array('id' => $orders_status['orders_status_id'],'text' => $orders_status['orders_status_name']);
		$orders_status_array[$orders_status['orders_status_id']] = $orders_status['orders_status_name'];
	}

	$status = $response['STATUS'];
	$pay_id = $response['PAYID'];
	$order_id = $response['orderID'];	
	$amt = '';	
	$res_amount = $response['amount'];
	if($res_amount){ $amt = " <br> Amount: ".$res_amount; }	
	
	$ogone_statuses = ogone::get_ogone_statuses();	
	$status_id_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = '".$ogone_statuses[$status]."' limit 1");
	if (tep_db_num_rows($status_id_query)) {
		$status_id = tep_db_fetch_array($status_id_query);
	}
	
	$ord_pm = array();
	$ord_qry = tep_db_query("select payment_method from ".TABLE_ORDERS." where orders_id = ".$order_id." limit 1");
	if (tep_db_num_rows($ord_qry)) {
		$ord_pm = tep_db_fetch_array($ord_qry);
	}
	
	$pmstring = $ord_pm['payment_method'];
	$findstr   = 'Ogone';
	$pos = strpos($pmstring, $findstr);
	
	if($pos!==false){	
		if($status=='8' || $status=='81'){
			$current_status = 0;
		}
		else{
			$check_current_qry = "select o.orders_id from ".TABLE_ORDERS." o left join ".TABLE_ORDERS_STATUS_HISTORY." osh on osh.orders_id = o.orders_id where o.orders_id = ".$order_id." and ((o.orders_status=".$status_id['orders_status_id'].") OR (osh.orders_status_id in (".$status_id['orders_status_id'].")))";		
			$check_current_status = tep_db_query($check_current_qry); 
			$current_status = tep_db_num_rows($check_current_status);
		}
		
		if($current_status==0) {										
			$stat_name = $ogone_statuses[$status];
			$stat_exp = explode('[',$stat_name);
			$comment_orderstatus = "Shop OrderID: ".$order_id." <br> Ogone PayID: ".$pay_id." <br> Ogone status: ".$status."-".$stat_exp[0].$amt;
			$sql_data_array = array('orders_id' => (int)$order_id, 
			                                'orders_status_id' => $status_id['orders_status_id'], 
			                                'date_added' => 'now()', 
			                                'customer_notified' => '1',
			                                'comments' => $comment_orderstatus);
			                                
			tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $status_id['orders_status_id'] . "', last_modified = now() where orders_id = '" . (int)$order_id . "'");
			tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
			$order_updated = true;
		}
		else{
			return false;
		}
	}
	else{
		return false;	
	}
}

?>